<template src="./template.html"></template>

<script lang="ts">
import { getModule, Watch } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import { api, api_key_tiny_editor, regexEmail } from "~/common/constaint";
import _, { cloneDeep } from "lodash";

function deepEqual(obj1: any, obj2: any) {
  return JSON.stringify(obj1) === JSON.stringify(obj2);
}
@Component({
  components: {
    LoadingComponent: () => import("@/components/Utils/Loading/index.vue"),
  },
})
export default class AdminSettingsEmailComponent extends Vue {
  api_key_tiny_editor = api_key_tiny_editor;
  tab = 0;
  slug = "";
  cloneMail = {};
  isNotChangeMail = true;

  email = {} as any;
  emailSend = "";
  created() {
    this.slug = this.$route.params?.slug.replaceAll("-", " ") || "";
    this.orderName = `${this.slug} {{order_name}}`;
  }
  mounted() {
    this.onGetListAbandon();
  }
  couponCode = "";

  get loadingFullPage() {
    return this.$store.state.adminProduct.loadingFullPage;
  }

  set loadingFullPage(val: any) {
    this.$store.commit("adminProduct/setLoadingFullPage", val);
  }
  async saveChanges() {
    try {
      const body = {
        timestamp: this.email.timestamp,
        discount: parseInt(this.email.discount),
        emailSubject: this.email.emailSubject,
        emailTemplate: this.email.emailTemplate,
        time: this.email.time || 1,
        coupon: {
          code: this.couponCode,
        },
      };
      await this.$api.abandon.edit(body);
      this.$pushNotification.success("Update successfully");
      // this.onGetListSellerPayment();
      this.onGetListAbandon();
      this.isNotChangeMail = true;
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  onGetListAbandon() {
    this.$store
      .dispatch("adminSetting/onGetListAbandon", { ctx: this })
      .then((result) => {
        const findEmail = {
          ...result.find((item: any) => item._id == this.slug),
        };
        this.email = findEmail;
        if (this.email?.couponId?.code) {
          this.couponCode = this.email.couponId.code;
        }
        this.cloneMail = cloneDeep(this.email);
      });
  }

  get listAbandon() {
    return this.$store.state?.adminSetting?.listAbandon || [];
  }

  order = {
    detail: "",
    email: "",
    variantCustom: `{{discount}}\n{{coupon}}`,
  };

  orderName = "";
  time = 300;
  listTime = [
    { name: "5 minutes", value: 300 },
    { name: "10 minutes", value: 600 },
    { name: "20 minutes", value: 1200 },
    { name: "30 minutes", value: 1800 },
    { name: "1h hour", value: 3600 },
    { name: "12 hours", value: 43200 },
    { name: "24 hours", value: 86400 },
  ];
  listValue = [
    { name: "5%", value: 5 },
    { name: "10%", value: 10 },
    { name: "15%", value: 15 },
  ];
  resetContent = false;
  editEmailDialog = false;

  typeDiscountList = [
    // {
    //   id: 1,
    //   name: "FREESHIP",
    // },
    {
      id: 1,
      name: "Percentage",
    },
    // {
    //   id: 3,
    //   name: "Fixed Amount",
    // },
  ];
  discountType = 1;
  dialogDiscardChange = false;

  saveCloseDialog() {
    if (!this.couponCode) {
      return this.$pushNotification.error("Please enter discount code");
    }
    if (!this.email.discount) {
      return this.$pushNotification.error("Please enter discount value");
    }
    this.editEmailDialog = false;
  }
  openDialogDiscardChange() {
    this.dialogDiscardChange = true;
  }
  discardChange() {
    this.dialogDiscardChange = false;
    this.email = this.cloneMail;
    this.isNotChangeMail = true;
  }

  loadingBtn = false;
  async onSendMain() {
    try {
      this.loadingBtn = true;
      if (!this.emailSend) {
        return this.$pushNotification.error(`Please enter email`);
      } else if (!regexEmail.test(this.emailSend)) {
        return this.$pushNotification.error(`Email not invalid`);
      }
      if (this.email.time === 1) {
        await this.$api.adminSendMail.abandonedFirst(this.emailSend);
      }
      if (this.email.time === 2) {
        await this.$api.adminSendMail.abandonedSecond(this.emailSend);
      }
      if (this.email.time === 3) {
        await this.$api.adminSendMail.abandonedThird(this.emailSend);
      }
      this.$pushNotification.success("Send email successfully");
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingBtn = false;
    }
  }

  get initEditor() {
    return {
      height: 400,
      image_title: true,
      automatic_uploads: true,
      //@ts-ignore
      file_picker_callback: function (cb, value, meta) {
        var input = document.createElement("input");
        input.setAttribute("type", "file");
        input.setAttribute("accept", "image/*");
        input.onchange = function () {
          //@ts-ignore
          var file = this.files[0];

          var reader = new FileReader();
          reader.onload = function () {
            var id = "blobid" + new Date().getTime();
            var blobCache =
              //@ts-ignore
              tinymce.activeEditor.editorUpload.blobCache;
            //@ts-ignore
            var base64 = reader.result.split(",")[1];
            var blobInfo = blobCache.create(id, file, base64);
            blobCache.add(blobInfo);
            cb(blobInfo.blobUri(), { title: file.name });
          };
          reader.readAsDataURL(file);
        };

        input.click();
      },
      file_picker_types: "image",
      plugins: ["lists link image code help wordcount"],
      toolbar:
        "undo redo | formatselect | bold italic | forecolor alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | image link media template codesample inserttable | charmap emoticons hr | pagebreak nonbreaking anchor toc | insertdatetime | help",
    };
  }

  @Watch("email.emailSubject")
  checkChangeMailEmailSubject() {
    this.isNotChangeMail = deepEqual(this.cloneMail, this.email);
  }

  @Watch("email.emailTemplate")
  checkChangeMailEmailTemplate() {
    this.isNotChangeMail = deepEqual(this.cloneMail, this.email);
  }

  @Watch("email.discount")
  checkChangeMailDiscount() {
    this.isNotChangeMail = deepEqual(this.cloneMail, this.email);
  }

  @Watch("couponCode")
  checkChangeMailcouponCode() {
    this.isNotChangeMail = deepEqual(
      this.couponCode,
      this.email?.couponId?.code
    );
  }
  checkChangeMailTimeStamp() {
    this.isNotChangeMail = deepEqual(this.cloneMail, this.email);
  }
}
</script>

<style></style>
